#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "defines.h"
#include "pcx.h"

int PCX_Load ( PCX * pcx, u8 *file, int datalen )
	{
		int filesize;
		int s;
		int curofs;
		int srci = 0;
		int bytesperline;
		BOOL compressed;
		u16 x1,y1,x2,y2;
		int i;
		u8 * data;

		filesize = datalen;
		s = datalen;
		if ( file==NULL )
			{
				return 1;
			}

		datalen -= 128+769;
		data = &file[128];

		curofs=0;
		if (file[curofs++]!=0x0a)
			return 1;
		if (file[curofs++]!=0x05)
			return 1;

		if (file[curofs++]==0)
			compressed = FALSE;
		else
			compressed = TRUE;

		if (file[curofs++]!=8)
			return 1;
		
		x1  = file[curofs++];
		x1 |= file[curofs++]<<8;
		y1  = file[curofs++];
		y1 |= file[curofs++]<<8;
		x2  = file[curofs++];
		x2 |= file[curofs++]<<8;
		y2  = file[curofs++];
		y2 |= file[curofs++]<<8;
		
		bytesperline = file[66];
		bytesperline |= file[67]<<8;

		pcx->width = (x2-x1)+1;
		pcx->height= (y2-y1)+1;

		if ( (pcx->data = malloc ( pcx->width*pcx->height ))==NULL )
			{
				return 1;
			}

		if (compressed)
			{
				int i=0;
				int s=pcx->width*pcx->height;
				int countlinebytes = pcx->width;
				srci = 0;
				
				while (i<s)
					{
						u8 c = data[srci++];

						if ((c&0xc0)==0xc0)
							{
								int l = c&~0xc0;
								int j;
								u8 d = data[srci++];
								for (j=0;j<l;j++)
									{
										pcx->data[i++] = d;
										countlinebytes--;
									}
							} else
							{
								pcx->data[i++] = c;
								countlinebytes--;
							}
						
						if (countlinebytes<=0)
							{
								countlinebytes = pcx->width;
								srci+=bytesperline-pcx->width;
							}
					}
			} else
			{
				memcpy ( pcx->data, data, datalen );
			}

/*		curofs = srci + 128;*/
		curofs = filesize-769;
		if (file[curofs++]!=0x0c)
			{
				free ( pcx->data );
				pcx->data = NULL;
				return 1;
			}

		for (i=0;i<256;i++)
			{
				pcx->pal[i].r = file[curofs++];
				pcx->pal[i].g = file[curofs++];
				pcx->pal[i].b = file[curofs++];
			}

		return 0;
	}

void PCX_Free ( PCX * pcx )
	{
		if (pcx->data!=NULL)
			{
				free (pcx->data);
				pcx->data = NULL;
			}
	}

