/* zfrequest.h */
#ifndef __ZFREQUEST_H__
#define __ZFREQUEST_H__

#ifdef __cplusplus
extern "C" {
#endif

#include "ziplist.h"
#include "defines.h"

#include "gpgraphic.h"
#include "gpstdlib.h"
#include "gpstdio.h"
#include "gpdef.h"

typedef struct ZFREQ_PAL
	{
		u8 r,g,b;
	} ZFREQ_PAL;

typedef struct ZIPFREQUEST
  {
    GPDRAWSURFACE * gpDraw;   /* Pointer to an array of 2 GPDRAWSURFACE structs */
    int numGpDraw;
    void (*renderBG)(GPDRAWSURFACE*);
    int surf;
    char * filename;          /* Pointer to a buffer for the selected file */
    char * preselect;
    FINFO ** pathlist;
    int pathlistsize;
    ZIPLIST * ziplist;        /* Pointer to a ZIPLIST struct */
    BOOL enableCancel;
    u8 col_pathname;
    u8 col_dir;
    u8 col_file;
    u8 col_info;
    u8 col_bg;
    u8 col_xor;
    BOOL zip;
    BOOL fade;
    ZFREQ_PAL * palette;
  } ZIPFREQUEST;
  

int ZIPFileRequest ( ZIPFREQUEST * req );
int SMCFileRequest ( ZIPFREQUEST * req );
int GpFileRequest ( ZIPFREQUEST * req );

#ifdef __cplusplus
}
#endif

#endif
