#ifndef __ZIPLIST_H__
#define __ZIPLIST_H__

#ifdef __cplusplus
extern "C" {
#endif

#include "unzip.h"

typedef struct FINFO
  {
    int size;
    int isdir;
    char *name;
    int userdata;
  } FINFO;

typedef struct DINFO
	{
		char * name;
		int size;
		int * dir;
	} DINFO;

typedef struct ZIPLIST
	{
		FINFO * ziplist;
		int ziplistsize;
		DINFO * dirlist;
		int dirlistsize;
	} ZIPLIST;

int load_ziplist ( const char * fname, ZIPLIST * ziplist );
void free_ziplist ( ZIPLIST * ziplist );
int build_ziplist ( const char * fname, ZIPLIST * ziplist );
int save_ziplist ( const char * fname, ZIPLIST * ziplist );

void sortdir ( FINFO ** dest, int dirsize );

FINFO ** ziplist_directory ( const char * pathname, ZIPLIST * ziplist, int * dirsize );

FINFO ** ziplist_dir ( const char * pathname, FINFO * ziplist, int ziplistsize, int * dirsize );

#ifdef __cplusplus
}
#endif

#endif
