#include <windows.h>
#include <stdlib.h>
#include <tchar.h>
#include <shellapi.h>
#include "archdep.h"
#include "../../emu/defines.h"
#include "icon.h"



LRESULT CALLBACK graywinWindowProc(
  HWND hwnd,
  UINT uMsg,
  WPARAM wParam,
  LPARAM lParam)
  {

    EMU * emu;

   emu = (EMU*)GetWindowLong ( hwnd, GWL_USERDATA );

   switch(uMsg) {
      case WM_DROPFILES:
        {
          char fname[256];
          HDROP hDrop = (HDROP)wParam;
          fname[255]='\0';

          DragQueryFile ( hDrop, 0, fname, sizeof(fname) );
          if (!EMU_LoadROM ( emu, fname ))
            MessageBox(hwnd,"Load ROM failed","Error",MB_OK);
/*            printf("Couldn't load ROM from %s\n", fname);*/
          DragFinish ( hDrop );
          break;
        }

      default:
         return DefWindowProc(hwnd, uMsg, wParam, lParam);
         break;
   }

   return 1;
}


int init_window(EMU * emu, int width, int height) {

   char windowid[100];
   WNDCLASSEX wcex;
   RECT rect;
   HINSTANCE hInst = GetModuleHandle(NULL);

   ZeroMemory(&wcex, sizeof(wcex));
   wcex.cbSize = sizeof(wcex);
   wcex.style = CS_BYTEALIGNCLIENT;
   wcex.lpfnWndProc = graywinWindowProc;
   wcex.hInstance = hInst;
   wcex.hCursor = LoadCursor(NULL, IDC_ARROW);
   wcex.hIcon = LoadIcon(hInst, MAKEINTRESOURCE(IDI_ICON));
   wcex.hbrBackground = (HBRUSH)GetStockObject(GRAY_BRUSH);
   /*wcex.lpszMenuName = MAKEINTRESOURCE(IDR_MENU);*/
   wcex.lpszClassName = "Mainframe";

   if (!RegisterClassEx(&wcex)) {
      MessageBox(NULL, "could not register class", "Error", MB_ICONERROR);
      return 0;
   }

   ZeroMemory(&rect, sizeof(RECT));
   rect.right = width;
   rect.bottom = height;
   AdjustWindowRectEx(&rect, WS_OVERLAPPEDWINDOW, TRUE, 0);
   emu->menuh = (rect.bottom-rect.top)-height;

   emu->g_hwnd = CreateWindowEx(
      0,
      "Mainframe",
      "SDL+Win32",
      WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT,
      CW_USEDEFAULT,
      abs(rect.left) + rect.right,
      abs(rect.top) + rect.bottom,
      NULL,
      NULL,
      hInst,
      NULL);

   SetWindowLong((HWND)(emu->g_hwnd), GWL_USERDATA, (LONG)emu);

   ZeroMemory(&rect, sizeof(RECT));
   rect.right = width;
   rect.bottom = height;
   AdjustWindowRectEx(&rect, WS_OVERLAPPEDWINDOW, FALSE, 0);

   if (!emu->g_hwnd) {
      MessageBox(NULL, "could not create window", "Error", MB_ICONERROR);
      return 0;
   }

   strcpy(windowid, "SDL_WINDOWID=");
   _ltoa((long)emu->g_hwnd, windowid+13, 10);
   _putenv(windowid);

   DragAcceptFiles ((HWND)emu->g_hwnd, TRUE);

   return 1;
}
