/* defines.h */

#ifndef __DEFINES_H__
#define __DEFINES_H__


typedef unsigned char u8;
typedef unsigned short u16;
typedef unsigned int u32;
typedef signed char s8;
typedef signed short s16;
typedef int s32;


typedef union {
#ifdef LITTLE_ENDIAN
  struct {

    u8 low;
    u8 high;
  } abyte;
#else
  struct {

    u8 high;
    u8 low;
  } abyte;
#endif
  u16 aword;
} union_word;


typedef union {
#ifdef  LITTLE_ENDIAN
  struct {

    union_word low;
    union_word high;
  } aword;
#else
  struct {

    union_word high;
    union_word low;
  } aword;
#endif
  u32 adword;
} union_dword;


#ifndef BOOL
#define BOOL  int
#endif
#ifndef TRUE
#define TRUE  1
#endif
#ifndef FALSE
#define FALSE 0
#endif

#ifndef NULL
#define NULL  0
#endif

#endif
