/* Z80_macros.h */

#ifndef __Z80_MACROS_H__
#define __Z80_MACROS_H__

#include "Z80.h"
#include "../defines.h"

#define BYTE2WORD(a)  ((u16)(s16)(s8)a)

#define MASTERLATOR
/*#define NON_OO*/

#ifdef NON_OO
#define cpu_PC cpuPC
#define cpu_SP cpuSP
#define cpu_AF cpuAF
#define cpu_BC cpuBC
#define cpu_DE cpuDE
#define cpu_HL cpuHL
#define cpu_IX cpuIX
#define cpu_IY cpuIY
#define cpu_data cpudata
#define cpu_af cpuaf
#define cpu_bc cpubc
#define cpu_de cpude
#define cpu_hl cpuhl
#define cpu_IFF cpuIFF
#else

#define cpu_getPC cpu->PC.aword
#define cpu_setPC(a) (cpu->PC.aword = a)

#define cpu_getPCh cpu->PC.abyte.high
#define cpu_getPCl cpu->PC.abyte.low

#define cpu_getSP cpu->SP.aword
#define cpu_setSP(a) (cpu->SP.aword = a)

#define cpu_getSPh cpu->SP.abyte.high
#define cpu_getSPl cpu->SP.abyte.low

#define cpu_getS cpu->SP.abyte.high
#define cpu_getP cpu->SP.abyte.low

#define cpu_setSPh(a) (cpu->SP.abyte.high = a)
#define cpu_setSPl(a) (cpu->SP.abyte.low = a)

#define cpu_getAF cpu->AF.aword
#define cpu_setAF(a) (cpu->AF.aword = a)

#define cpu_getA cpu->AF.abyte.high
#define cpu_setA(a) (cpu->AF.abyte.high = a)

#define cpu_getF cpu->AF.abyte.low
#define cpu_setF(a) (cpu->AF.abyte.low = a)

#define cpu_getBC cpu->BC.aword
#define cpu_setBC(a) (cpu->BC.aword = a)

#define cpu_getB cpu->BC.abyte.high
#define cpu_setB(a) (cpu->BC.abyte.high = a)

#define cpu_getC cpu->BC.abyte.low
#define cpu_setC(a) (cpu->BC.abyte.low = a)

#define cpu_getDE cpu->DE.aword
#define cpu_setDE(a) (cpu->DE.aword = a)

#define cpu_getD cpu->DE.abyte.high
#define cpu_setD(a) (cpu->DE.abyte.high = a)

#define cpu_getE cpu->DE.abyte.low
#define cpu_setE(a) (cpu->DE.abyte.low = a)

#define cpu_getHL cpu->HL.aword
#define cpu_setHL(a) (cpu->HL.aword = a)

#define cpu_getH cpu->HL.abyte.high
#define cpu_setH(a) (cpu->HL.abyte.high = a)

#define cpu_getL cpu->HL.abyte.low
#define cpu_setL(a) (cpu->HL.abyte.low = a)

#define cpu_getIX cpu->IX.aword
#define cpu_setIX(a) (cpu->IX.aword = a)

#define cpu_getIXh cpu->IX.abyte.high
#define cpu_setIXh(a) (cpu->IX.abyte.high = a)

#define cpu_getIXl cpu->IX.abyte.low
#define cpu_setIXl(a) (cpu->IX.abyte.low = a)

#define cpu_getIY cpu->IY.aword
#define cpu_setIY(a) (cpu->IY.aword = a)

#define cpu_getIYh cpu->IY.abyte.high
#define cpu_setIYh(a) (cpu->IY.abyte.high = a)

#define cpu_getIYl cpu->IY.abyte.low
#define cpu_setIYl(a) (cpu->IY.abyte.low = a)

#define cpu_getaf cpu->af.aword
#define cpu_setaf(a) (cpu->af.aword = a)

#define cpu_geta cpu->af.abyte.high
#define cpu_seta(a) (cpu->af.abyte.high = a)

#define cpu_getf cpu->af.abyte.low
#define cpu_setf(a) (cpu->af.abyte.low = a)

#define cpu_getbc cpu->bc.aword
#define cpu_setbc(a) (cpu->bc.aword = a)

#define cpu_getb cpu->bc.abyte.high
#define cpu_setb(a) (cpu->bc.abyte.high = a)

#define cpu_getc cpu->bc.abyte.low
#define cpu_setc(a) (cpu->bc.abyte.low = a)

#define cpu_getde cpu->de.aword
#define cpu_setde(a) (cpu->de.aword = a)

#define cpu_getd cpu->de.abyte.high
#define cpu_setd(a) (cpu->de.abyte.high = a)

#define cpu_gete cpu->de.abyte.low
#define cpu_sete(a) (cpu->de.abyte.low = a)

#define cpu_gethl cpu->hl.aword
#define cpu_sethl(a) (cpu->hl.aword = a)

#define cpu_geth cpu->hl.abyte.high
#define cpu_seth(a) (cpu->hl.abyte.high = a)

#define cpu_getl cpu->hl.abyte.low
#define cpu_setl(a) (cpu->hl.abyte.low = a)
/*

#define getComp(a,b) ((cpu->a << 8) | (cpu->b & 0xff))
#define setComp(a,b,c) cpu->a = (c) >> 8; cpu->b= (c) & 0xff;

#define cpu_getPC cpu->PC
#define cpu_setPC(a) (cpu->PC = (a))
#define cpu_getPCh (cpu->PC >> 8)
#define cpu_getPCl (cpu->PC & 0xff)

#define cpu_getSP cpu->SP
#define cpu_setSP(a) (cpu->SP = (a))
#define cpu_getSPh (cpu->SP >> 8)
#define cpu_getSPl (cpu->SP & 0xff)
#define cpu_getS cpu_getSPh
#define cpu_getP cpu_getSPl
#define cpu_setSPh(a) (cpu->SP = (cpu->SP & 0xff) | ((a) << 8))
#define cpu_setSPl(a) (cpu->SP = (cpu->SP & 0xff00) | ((a) & 0xff))

#define cpu_getAF getComp(A,F)
#define cpu_setAF(a) setComp(A,F,a)
#define cpu_getA cpu->A
#define cpu_setA(a) (cpu->A = (a))
#define cpu_getF cpu->F
#define cpu_setF(a) (cpu->F = (a))

#define cpu_getBC getComp(B,C)
#define cpu_setBC(a) setComp(B,C,a)
#define cpu_getB cpu->B
#define cpu_setB(a) (cpu->B = (a))
#define cpu_getC cpu->C
#define cpu_setC(a) (cpu->C = (a))

#define cpu_getDE getComp(D,E)
#define cpu_setDE(a) setComp(D,E,a)
#define cpu_getD cpu->D
#define cpu_setD(a) (cpu->D = (a))
#define cpu_getE cpu->E
#define cpu_setE(a) (cpu->E = (a))

#define cpu_getHL getComp(H,L)
#define cpu_setHL(a) setComp(H,L,a)
#define cpu_getH cpu->H
#define cpu_setH(a) (cpu->H = (a))
#define cpu_getL cpu->L
#define cpu_setL(a) (cpu->L = (a))

#define cpu_getIX cpu->IX
#define cpu_setIX(a) (cpu->IX = (a))
#define cpu_getIXh (cpu->IX >> 8)
#define cpu_setIXh(a) (cpu->IX = ((cpu->IX & 0xff) | ((a) << 8)))
#define cpu_getIXl (cpu->IX & 0xff)
#define cpu_setIXl(a) (cpu->IX = ((cpu->IX & 0xff00) | ((a) & 0xff)))

#define cpu_getIY cpu->IY
#define cpu_setIY(a) (cpu->IY = a)
#define cpu_getIYh (cpu->IY >> 8)
#define cpu_setIYh(a) (cpu->IY = ((cpu->IY & 0xff) | ((a) << 8)))
#define cpu_getIYl (cpu->IY & 0xff)
#define cpu_setIYl(a) (cpu->IY = ((cpu->IY & 0xff00) | ((a) & 0xff)))

#define cpu_getaf getComp(a,f)
#define cpu_setaf(x) setComp(a,f,x)
#define cpu_geta cpu->a
#define cpu_seta(x) (cpu->a = (x))
#define cpu_getf cpu->f
#define cpu_setf(a) (cpu->f = (a))

#define cpu_getbc getComp(b,c)
#define cpu_setbc(a) setComp(b,c,a)
#define cpu_getb cpu->b
#define cpu_setb(a) (cpu->b = (a))
#define cpu_getc cpu->c
#define cpu_setc(a) (cpu->c = (a))

#define cpu_getde getComp(d,e)
#define cpu_setde(a) setComp(d,e,a)
#define cpu_getd cpu->d
#define cpu_setd(a) (cpu->d = (a))
#define cpu_gete cpu->e
#define cpu_sete(a) (cpu->e = (a))

#define cpu_gethl getComp(h,l)
#define cpu_sethl(a) setComp(h,l,a)
#define cpu_geth cpu->h
#define cpu_seth(a) (cpu->h = (a))
#define cpu_getl cpu->l
#define cpu_setl(a) (cpu->l = (a))
*/
#define cpu_IFF cpu->IFF
#endif

#ifdef MASTERLATOR
#define read(a)		readm(a)
#define write(a,b) writem(a,b)
#else
#define read(a)   (cpu->readMem(cpu,a))
#define write(a,b)  (cpu->writeMem((Z80*)cpu,a,b))
#endif

#define read16(a) (read(a) | (read(a + 1) << 8))
#define write16(a,b)  write(a,b);write(a + 1, b >> 8);
#define in(a)   (cpu->in((Z80*)cpu,a))
#define out(a,b)  (cpu->out((Z80*)cpu,a,b))



#define M_PUSH(ah, al)\
    write(cpu_getSP-1, cpu_get##ah);\
    write(cpu_getSP-2, cpu_get##al);\
		cpu_setSP(cpu_getSP - 2);

#define M_POP(ah, al)\
    cpu_set##al(read(cpu_getSP+0));\
    cpu_set##ah(read(cpu_getSP+1));\
		cpu_setSP(cpu_getSP + 2);



#define M_READ_PC(c,d)\
    (read(cpu_getPC() + d))

#define M_READ_PC16(c,d)\
    (M_READ_PC(c,d) | (M_READ_PC(c,d + 1)<<8))

#define M_READ_IX_d(d)\
    (read(cpu_getIX() + BYTE2WORD(d)))

#define M_WRITE_IX_d(d,a)\
    (write(cpu_getIX() + BYTE2WORD(d),a)))

#define M_READ_IY_d(d)\
    (read(cpu_getIY() + BYTE2WORD(d)))

#define M_WRITE_IY_d(d,a)\
    (write(cpu_IY.aword+BYTE2WORD(d),a)))



#define PUSH_PC \
			write(cpu_getSP - 2, cpu_getPC); \
			write(cpu_getSP - 1, cpu_getPC >> 8); \
			cpu_setSP(cpu_getSP - 2);

/*
	    write(cpu_SP.aword-2, cpu_PC.abyte.low );\
      write(cpu_SP.aword-1, cpu_PC.abyte.high);\
      cpu_SP.aword-=2;
*/

#define POP_PC \
			cpu_setPC(read(cpu_getSP) | (read(cpu_getSP + 1) << 8)); \
			cpu_setSP(cpu_getSP + 2);

/*    	cpu_PC.abyte.low  = read(cpu_SP.aword++);\
      cpu_PC.abyte.high = read(cpu_SP.aword++);*/



/**** JP ****/
#define M_JP_nn   cpu_setPC(cpu_getPC + 1);\
      t.aword.low.abyte.low  = read(cpu_getPC);\
      t.aword.low.abyte.high = read(cpu_getPC + 1);\
      cpu_setPC(t.aword.low.aword);\
      CYCLES(10);

#define M_JP_NZ_nn  if ( cpu_getF & FLAG_Z ) { cpu_setPC(cpu_getPC + 3); CYCLES(10); } else { M_JP_nn; }
#define M_JP_Z_nn if ( cpu_getF & FLAG_Z ) { M_JP_nn; } else { cpu_setPC(cpu_getPC + 3); CYCLES(10); }
#define M_JP_NC_nn  if ( cpu_getF & FLAG_C ) { cpu_setPC(cpu_getPC + 3); CYCLES(10); } else { M_JP_nn; }
#define M_JP_C_nn if ( cpu_getF & FLAG_C ) { M_JP_nn; } else { cpu_setPC(cpu_getPC + 3); CYCLES(10); }
#define M_JP_PO_nn  if ( cpu_getF & FLAG_PV) { cpu_setPC(cpu_getPC + 3); CYCLES(10); } else { M_JP_nn; }
#define M_JP_PE_nn  if ( cpu_getF & FLAG_PV) { M_JP_nn; } else { cpu_setPC(cpu_getPC + 3); CYCLES(10); }
#define M_JP_P_nn if ( cpu_getF & FLAG_S ) { cpu_setPC(cpu_getPC + 3); CYCLES(10); } else { M_JP_nn; }
#define M_JP_N_nn if ( cpu_getF & FLAG_S ) { M_JP_nn; } else { cpu_setPC(cpu_getPC + 3); CYCLES(10); }
#define M_JP_HL   cpu_setPC(cpu_getHL); CYCLES(4);


/**** JR ****/
#define JR_e    cpu_setPC(cpu_getPC + BYTE2WORD(read(cpu_getPC + 1))+2);
#define M_JR_e    JR_e; CYCLES(12);
#define M_JR_C_e  if ( cpu_getF & FLAG_C ) { M_JR_e; } else { cpu_setPC(cpu_getPC + 2); CYCLES(7); }
#define M_JR_NC_e if ( cpu_getF & FLAG_C ) { cpu_setPC(cpu_getPC + 2); CYCLES(7); } else { M_JR_e; }
#define M_JR_Z_e  if ( cpu_getF & FLAG_Z ) { M_JR_e; } else { cpu_setPC(cpu_getPC + 2); CYCLES(7); }
#define M_JR_NZ_e if ( cpu_getF & FLAG_Z ) { cpu_setPC(cpu_getPC + 2); CYCLES(7); } else { M_JR_e; }


#define M_CALL_nn t.aword.low.abyte.low  = read(cpu_getPC + 1);\
      t.aword.low.abyte.high = read(cpu_getPC + 2);\
      cpu_setPC(cpu_getPC + 3);PUSH_PC;\
      cpu_setPC(t.aword.low.aword);\
      CYCLES(17);

#define M_CALL_NZ_nn  if ( cpu_getF & FLAG_Z ) { cpu_setPC(cpu_getPC + 3); CYCLES(10); } else { M_CALL_nn; }
#define M_CALL_Z_nn if ( cpu_getF & FLAG_Z ) { M_CALL_nn; } else { cpu_setPC(cpu_getPC + 3); CYCLES(10); }
#define M_CALL_NC_nn  if ( cpu_getF & FLAG_C ) { cpu_setPC(cpu_getPC + 3); CYCLES(10); } else { M_CALL_nn; }
#define M_CALL_C_nn if ( cpu_getF & FLAG_C ) { M_CALL_nn; } else { cpu_setPC(cpu_getPC + 3); CYCLES(10); }
#define M_CALL_PO_nn  if ( cpu_getF & FLAG_PV) { cpu_setPC(cpu_getPC + 3); CYCLES(10); } else { M_CALL_nn; }
#define M_CALL_PE_nn  if ( cpu_getF & FLAG_PV) { M_CALL_nn; } else { cpu_setPC(cpu_getPC +3); CYCLES(10); }
#define M_CALL_P_nn if ( cpu_getF & FLAG_S ) { cpu_setPC(cpu_getPC + 3); CYCLES(10); } else { M_CALL_nn; }
#define M_CALL_N_nn if ( cpu_getF & FLAG_S ) { M_CALL_nn; } else { cpu_setPC(cpu_getPC + 3); CYCLES(10); }

#define M_RET   POP_PC; CYCLES(10);
#define M_RET_NZ  if ( cpu_getF & FLAG_Z ) { cpu_setPC(cpu_getPC + 1); CYCLES(5); } else { POP_PC; CYCLES(11); }
#define M_RET_Z   if ( cpu_getF & FLAG_Z ) { POP_PC; CYCLES(11); } else { cpu_setPC(cpu_getPC + 1); CYCLES(5); }
#define M_RET_NC  if ( cpu_getF & FLAG_C ) { cpu_setPC(cpu_getPC + 1); CYCLES(5); } else { POP_PC; CYCLES(11); }
#define M_RET_C   if ( cpu_getF & FLAG_C ) { POP_PC; CYCLES(11); } else { cpu_setPC(cpu_getPC + 1); CYCLES(5); }
#define M_RET_PO  if ( cpu_getF & FLAG_PV) { cpu_setPC(cpu_getPC + 1); CYCLES(5); } else { POP_PC; CYCLES(11); }
#define M_RET_PE  if ( cpu_getF & FLAG_PV) { POP_PC; CYCLES(11); } else { cpu_setPC(cpu_getPC + 1); CYCLES(5); }
#define M_RET_P   if ( cpu_getF & FLAG_S ) { cpu_setPC(cpu_getPC + 1); CYCLES(5); } else { POP_PC; CYCLES(11); }
#define M_RET_N   if ( cpu_getF & FLAG_S ) { POP_PC; CYCLES(11); } else { cpu_setPC(cpu_getPC + 1); CYCLES(5); }

#define M_DJNZ_e  cpu_setB(cpu_getB - 1); if (cpu_getB==0) { cpu_setPC(cpu_getPC + 2); CYCLES(8); } else { JR_e; CYCLES(13); }


#define M_IN_A_n  cpu_AF.abyte.high = in(read(cpu_PC.aword+1)); cpu_PC.aword+=2; CYCLES(11);
#define M_OUT_n_A out(read(cpu_PC.aword+1),cpu_AF.abyte.high); cpu_PC.aword+=2; CYCLES(11);

#define M_ADD16(ah, al, bh, bl)  t.adword = (u32)cpu_get##ah##al + (u32)cpu_get##bh##bl;\
      cpu_setF((cpu_getF & ~(FLAG_H|FLAG_N|FLAG_C|FLAG_3|FLAG_5)) |\
             (t.aword.high.abyte.low & FLAG_C) |\
             ((t.aword.low.aword^cpu_get##ah##al^cpu_get##bh##bl)&0x1000?FLAG_H:0)|\
             (t.aword.low.abyte.high&(FLAG_3|FLAG_5)));\
      cpu_set##ah##al(t.aword.low.aword);

#define M_ADC16(ah, al, bh, bl)  tt.adword = (u32)cpu_get##bh##bl + (u32)(cpu_getF & FLAG_C);\
      t.adword = (u32)cpu_get##ah##al + tt.adword;\
      cpu_setF((t.aword.low.abyte.high & FLAG_S) |\
             (t.aword.low.aword==0?FLAG_Z:0) |\
             (t.aword.high.abyte.low & FLAG_C) |\
             (((t.aword.low.abyte.high^cpu_get##ah^cpu_get##bh) & 0x01)?FLAG_H:0)|\
             ((~(cpu_get##ah##al^cpu_get##bh##bl)&(cpu_get##bh##bl^t.aword.low.aword)&0x8000)?FLAG_PV:0)|\
             (t.aword.low.abyte.high&(FLAG_3|FLAG_5)));\
      cpu_set##ah##al(t.aword.low.aword);

#define M_SBC16(ah, al, bh, bl)  tt.adword = (u32)cpu_get##bh##bl + (u32)(cpu_getF & FLAG_C);\
      t.adword = (u32)cpu_get##ah##al - tt.adword;\
      cpu_setF((t.aword.low.abyte.high & FLAG_S) |\
             (t.aword.low.aword==0?FLAG_Z:0) |\
             (t.aword.high.abyte.low & FLAG_C) |\
             (((t.aword.low.aword^cpu_get##ah##al^cpu_get##bh##bl) & 0x0100)?FLAG_H:0)|\
             (((cpu_get##ah##al^cpu_get##bh##bl)&(cpu_get##ah##al^t.aword.low.aword)&0x8000)?FLAG_PV:0)|\
             (t.aword.low.abyte.high&(FLAG_3|FLAG_5)));\
      cpu_set##ah##al(t.aword.low.aword);

#define M_INC(a)  a++;\
      cpu_setF((cpu_getF & FLAG_C) | inctab[a]);

#define M_DEC(a)  a--;\
      cpu_setF((cpu_getF & FLAG_C) | dectab[a]);

#define M_INC_REG(a)  cpu_set##a(cpu_get##a + 1);\
      cpu_setF((cpu_getF & FLAG_C) | inctab[cpu_get##a]);

#define M_DEC_REG(a)  cpu_set##a(cpu_get##a - 1);\
      cpu_setF((cpu_getF & FLAG_C) | dectab[cpu_get##a]);


#define M_ADD(b) \
	cpu_setF(addtab[0][cpu_getA][b]); \
	cpu_setA(cpu_getA + b);

#define M_ADC(b) \
	t.aword.low.aword = cpu_getF & FLAG_C; \
	cpu_setF(addtab[t.aword.low.aword][cpu_getA][b]); \
	cpu_setA(cpu_getA + b + t.aword.low.aword);

#define M_SBC(b) \
	t.aword.low.aword = cpu_getF & FLAG_C; \
	cpu_setF(cptab[t.aword.low.aword][cpu_getA][b]); \
	cpu_setA(cpu_getA - (b + t.aword.low.aword));

#define M_SUB(b) cpu_setF(cptab[0][cpu_getA][b]); \
                 cpu_setA(cpu_getA - b);

#define M_CP(b) cpu_setF(cptab[0][cpu_getA][b]);

/*
#define M_INC(a)  a++;\
      cpu_AF.abyte.low = (cpu_AF.abyte.low & FLAG_C) |\
             SZTable[a] |\
             ((a&0x0f)?0:FLAG_H) |\
             (a==0x80?FLAG_PV:0) |\
             (a&(FLAG_3|FLAG_5));

#define M_DEC(a)  a--;\
      cpu_AF.abyte.low = (cpu_AF.abyte.low & FLAG_C) |\
             SZTable[a] |\
             ((a&0x0f)==0x0f?FLAG_H:0) |\
             (a==0x7f?FLAG_PV:0) |\
             FLAG_N |\
             (a&(FLAG_3|FLAG_5));

#define M_ADD(b)  t.aword.low.aword = (u16)cpu_AF.abyte.high + (u16)b; \
      cpu_AF.abyte.low = SZTable[t.aword.low.abyte.low] | \
             ((t.aword.low.abyte.low^cpu_AF.abyte.high^b)&FLAG_H) | \
             ((~(cpu_AF.abyte.high^b)&(b^t.aword.low.abyte.low)&0x80)?FLAG_PV:0) | \
             t.aword.low.abyte.high | \
             (t.aword.low.abyte.low & (FLAG_3|FLAG_5)); \
      cpu_AF.abyte.high = t.aword.low.abyte.low;

#define M_ADC(b)  dw.aword = (u16)b + (u16)(cpu_AF.abyte.low&FLAG_C); \
      t.aword.low.aword = (u16)cpu_AF.abyte.high + dw.aword; \
      cpu_AF.abyte.low = SZTable[t.aword.low.abyte.low] | \
             ((t.aword.low.abyte.low^cpu_AF.abyte.high^b)&FLAG_H) | \
             ((~(cpu_AF.abyte.high^b)&(b^t.aword.low.abyte.low)&0x80)?FLAG_PV:0) | \
             t.aword.low.abyte.high | \
             (t.aword.low.abyte.low&(FLAG_3|FLAG_5)); \
      cpu_AF.abyte.high = t.aword.low.abyte.low;

#define M_SBC(b)  dw.aword = (u16)b + (u16)(cpu_AF.abyte.low&FLAG_C);\
      t.aword.low.aword = (u16)cpu_AF.abyte.high - dw.aword;\
      cpu_AF.abyte.low = SZTable[t.aword.low.abyte.low] | \
             ((t.aword.low.abyte.low^cpu_AF.abyte.high^b)&FLAG_H) | \
             (((cpu_AF.abyte.high^b)&(cpu_AF.abyte.high^t.aword.low.abyte.low)&0x80)?FLAG_PV:0) | \
             -t.aword.low.abyte.high | \
             FLAG_N | \
             (dw.abyte.low&(FLAG_3|FLAG_5)); \
      cpu_AF.abyte.high = t.aword.low.abyte.low;

#define M_SUB(b)  t.aword.low.aword = (u16)cpu_AF.abyte.high - (u16)b;\
      cpu_AF.abyte.low = SZTable[t.aword.low.abyte.low] | \
             ((t.aword.low.abyte.low^cpu_AF.abyte.high^b)&FLAG_H) | \
             (((cpu_AF.abyte.high^b)&(cpu_AF.abyte.high^t.aword.low.abyte.low)&0x80)>>5) | \
             -t.aword.low.abyte.high | \
             FLAG_N | \
             (t.aword.low.abyte.low&(FLAG_3|FLAG_5));\
      cpu_AF.abyte.high = t.aword.low.abyte.low;

#define M_CP(b) t.aword.low.aword = (u16)cpu_AF.abyte.high - (u16)b;\
      cpu_AF.abyte.low = SZTable[t.aword.low.abyte.low] | \
             ((t.aword.low.abyte.low^cpu_AF.abyte.high^b)&FLAG_H) | \
             (((cpu_AF.abyte.high^b)&(cpu_AF.abyte.high^t.aword.low.abyte.low)&0x80)?FLAG_PV:0) | \
             -t.aword.low.abyte.high | \
             FLAG_N | \
             (cpu_AF.abyte.high & (FLAG_3|FLAG_5));
*/

#define M_AND(b)  cpu_setA(cpu_getA & b);\
      cpu_setF(PSZTable[cpu_getA] |  /* P,S,Z */\
             FLAG_H);        /* H */

#define M_OR(b)   cpu_setA(cpu_getA | b);\
      cpu_setF(PSZTable[cpu_getA]);   /* P,S,Z */

#define M_XOR(b)  cpu_setA(cpu_getA ^ b);\
      cpu_setF(PSZTable[cpu_getA]);   /* P,S,Z */


#define M_EX(a,b) t.aword.low.aword = cpu_get##a;\
      cpu_set##a(cpu_get##b);\
      cpu_set##b(t.aword.low.aword);


#define M_BIT(a,b)  cpu_setF((cpu_getF & FLAG_C) | PSZTable[(a)&(b)] | FLAG_H);

#define M_RLC(a)  t.aword.low.abyte.low = (a & 0x80)>>7;\
      a = (a << 1) | t.aword.low.abyte.low;\
      cpu_setF(PSZTable[a] | t.aword.low.abyte.low);

#define M_RL(a)   t.aword.low.abyte.low = (a&0x80)>>7;\
      a = (a<<1) | (cpu_getF & FLAG_C);\
      cpu_setF(PSZTable[a] | t.aword.low.abyte.low);

#define M_RRC(a)  t.aword.low.abyte.low = a & FLAG_C;\
      a = (a>>1) | (t.aword.low.abyte.low<<7);\
      cpu_setF(PSZTable[a] | t.aword.low.abyte.low);

#define M_RR(a)   t.aword.low.abyte.low = a & FLAG_C;\
      a = (a>>1) | ((cpu_getF & FLAG_C)<<7);\
      cpu_setF(PSZTable[a] | t.aword.low.abyte.low);

#define M_SLA(a)  t.aword.low.abyte.low = (a&0x80)>>7;\
      a <<= 1;\
      cpu_setF(PSZTable[a] | t.aword.low.abyte.low);

#define M_SRA(a)  t.aword.low.abyte.low = a & FLAG_C;\
      a = (a>>1) | (a&0x80);\
      cpu_setF(PSZTable[a] | t.aword.low.abyte.low);

#define M_SRL(a)  t.aword.low.abyte.low = a & FLAG_C;\
      a >>= 1;\
      cpu_setF(PSZTable[a] | t.aword.low.abyte.low);

#define M_SLL(a)	t.aword.low.abyte.low = (a&0x80)>>7;\
			a = (a << 1) | 1;\
			cpu_setF(PSZTable[a] | t.aword.low.abyte.low);

#define M_RLC_REG(a)  t.aword.low.abyte.low = (cpu_get##a & 0x80)>>7;\
      cpu_set##a((cpu_get##a << 1) | t.aword.low.abyte.low);\
      cpu_setF(PSZTable[cpu_get##a] | t.aword.low.abyte.low);

#define M_RL_REG(a)   t.aword.low.abyte.low = (cpu_get##a & 0x80)>>7;\
      cpu_set##a((cpu_get##a <<1) | (cpu_getF & FLAG_C));\
      cpu_setF(PSZTable[cpu_get##a] | t.aword.low.abyte.low);

#define M_RRC_REG(a)  t.aword.low.abyte.low = cpu_get##a & FLAG_C;\
      cpu_set##a((cpu_get##a>>1) | (t.aword.low.abyte.low<<7));\
      cpu_setF(PSZTable[cpu_get##a] | t.aword.low.abyte.low);

#define M_RR_REG(a)   t.aword.low.abyte.low = cpu_get##a & FLAG_C;\
      cpu_set##a((cpu_get##a>>1) | ((cpu_getF & FLAG_C)<<7));\
      cpu_setF(PSZTable[cpu_get##a] | t.aword.low.abyte.low);

#define M_SLA_REG(a)  t.aword.low.abyte.low = (cpu_get##a&0x80)>>7;\
      cpu_set##a(cpu_get##a << 1);\
      cpu_setF(PSZTable[cpu_get##a] | t.aword.low.abyte.low);

#define M_SRA_REG(a)  t.aword.low.abyte.low = cpu_get##a & FLAG_C;\
      cpu_set##a((cpu_get##a>>1) | (cpu_get##a&0x80));\
      cpu_setF(PSZTable[cpu_get##a] | t.aword.low.abyte.low);

#define M_SRL_REG(a)  t.aword.low.abyte.low = cpu_get##a & FLAG_C;\
      cpu_set##a(cpu_get##a >> 1);\
      cpu_setF(PSZTable[cpu_get##a] | t.aword.low.abyte.low);


#define M_INI   dw.abyte.low = in(cpu_getC);\
      write(cpu_getHL,dw.abyte.low);\
      cpu_setB(cpu_getB - 1);\
      cpu_setHL(cpu_getHL + 1);\
      cpu_setF((cpu_getB==0?FLAG_Z:0)|\
             (cpu_getB&(FLAG_3|FLAG_5|FLAG_S))|\
             ((dw.abyte.low>>6)&FLAG_N)|\
             (((u16)(cpu_getC+1)+(u16)dw.abyte.low)&0xff00?(FLAG_C|FLAG_H):0));

#define M_IND   dw.abyte.low = in(cpu_getC);\
      write(cpu_getHL,dw.abyte.low);\
      cpu_setB(cpu_getB - 1);\
      cpu_setHL(cpu_getHL - 1);\
      cpu_setF((cpu_getB==0?FLAG_Z:0)|\
             (cpu_getB&(FLAG_3|FLAG_5|FLAG_S))|\
             ((dw.abyte.low>>6)&FLAG_N)|\
             (((u16)(cpu_getC-1)+(u16)dw.abyte.low)&0xff00?(FLAG_C|FLAG_H):0));

#define M_OUTI    dw.abyte.low = read(cpu_getHL);\
      out(cpu_getC, dw.abyte.low);\
      cpu_setB(cpu_getB - 1);\
      cpu_setHL(cpu_getHL + 1);\
      cpu_setF((cpu_getB==0?FLAG_Z:0)|\
             (cpu_getB&(FLAG_3|FLAG_5|FLAG_S))|\
             ((dw.abyte.low>>6)&FLAG_N)|\
             (((u16)(cpu_getC+1)+(u16)dw.abyte.low)&0xff00?(FLAG_C|FLAG_H):0));

#define M_OUTD    dw.abyte.low = read(cpu_getHL);\
      out(cpu_getC, dw.abyte.low);\
      cpu_setB(cpu_getB - 1);\
      cpu_setHL(cpu_getHL - 1);\
      cpu_setF((cpu_getB==0?FLAG_Z:0)|\
             (cpu_getB&(FLAG_3|FLAG_5|FLAG_S))|\
             ((dw.abyte.low>>6)&FLAG_N)|\
             (((u16)(cpu_getC-1)+(u16)dw.abyte.low)&0xff00?(FLAG_C|FLAG_H):0));

#define M_LDI   write(cpu_getDE,read(cpu_getHL));\
      cpu_setDE(cpu_getDE + 1);cpu_setHL(cpu_getHL + 1);cpu_setBC(cpu_getBC - 1);\
      cpu_setF((cpu_getF & ~(FLAG_N|FLAG_H|FLAG_PV)) | (cpu_getBC==0?0:FLAG_PV));

#define M_LDD   write(cpu_getDE,read(cpu_getHL));\
      cpu_setDE(cpu_getDE - 1);cpu_setHL(cpu_getHL - 1);cpu_setBC(cpu_getBC - 1);\
      cpu_setF((cpu_getF & ~(FLAG_N|FLAG_H|FLAG_PV)) | (cpu_getBC==0?0:FLAG_PV));

#define M_CPI   dw.abyte.low = read(cpu_getHL);\
      t.aword.low.aword = cpu_getA - dw.abyte.low;\
      cpu_setHL(cpu_getHL + 1);cpu_setBC(cpu_getBC - 1);\
      cpu_setF((cpu_getF & FLAG_C) |\
             SZTable[t.aword.low.abyte.low] |\
               ((t.aword.low.abyte.low^cpu_getA^dw.abyte.low)&FLAG_H) |\
             (cpu_getBC==0?0:FLAG_PV) |\
             FLAG_N);

#define M_CPD   dw.abyte.low = read(cpu_getHL);\
      t.aword.low.aword = cpu_getA - dw.abyte.low;\
      cpu_setHL(cpu_getHL - 1);cpu_setBC(cpu_getBC - 1);\
      cpu_setF((cpu_getF & FLAG_C) |\
             SZTable[t.aword.low.abyte.low] |\
               ((t.aword.low.abyte.low^cpu_getA^dw.abyte.low)&FLAG_H) |\
             (cpu_getBC==0?0:FLAG_PV) |\
             FLAG_N);

#endif /* __Z80_MACROS_H__ */

