/* sn76489.h */
#ifndef __SN76489_H__
#define __SN76489_H__

#include "../defines.h"

typedef struct SN76489 {

  u16 freq;         /* Frequency (44100, 22050, 11025, ...) */
  u8 bits;          /* 8 or 16 */
  u8 channels;      /* 1 (mono) or 2 (stereo) */
  u16 buflen;       /* Length of the buffers in samples */
  u16 chanfreq[3];
  u16 chanvol [4];
  u32 sqofs[4];     /* 16.16bit fixed point */
  u32 sqwidth[4];   /* 16.16bit fixed point */
  BOOL pos[3];      /* TRUE = +, FALSE = - */
  void *buf[4];     /* Pointer to 4 buffers for the sound data */
  u8 lastchan;
  u16 noiseofs;
  BOOL chan3f;      /* Use channel 2 freq as the noise freq ? */
  BOOL FB;
} SN76489;

void SN76489_Init(SN76489 *snd, u16, u8, u8, u16);
void SN76489_Terminate(SN76489 *);
void SN76489_Cycle(SN76489 *, u16 *);
void SN76489_Write(SN76489 *, u8);
void SN76489_Reset(SN76489 *);

#endif
